import Qt 4.7
import "imports/XAComponents"
import "imports/XAComponents/date.js" as DateFunctions
import "imports/colibri"
import "Inspector"

Item {
    id: mainrectangle
    width: 480
    height: 420
    anchors.fill: parent

    property string windowTitle : qtWindowTitle
    property string windowGotFocus : qtWindowGotFocus
    property string platformID: qtPlatformID
    property string editionID: qtEditionID

    property string itemType: qtItemType
    property string itemUID: qtItemUID

    property string itemName: qtItemName
    property string itemCompletedDTS: qtItemCompletedDTS
    property string itemFlag: qtItemFlag

    property int itemPriority: qtItemPriority
    property string itemComment: qtItemComment
    property int itemAttachmentCount: qtItemAttachmentCount
    property int itemColor: qtItemColor

    property int itemAIDType: qtItemAIDType
    property string itemLocation: qtItemLocation    
    property string dtsreview : qtInputDTSReview
    property string context : qtInputContext
    property string itemSecurityLevelHR: qtInputSecurityLevelHR

    property int itemProgress: qtItemProgress
    property string dtsstart : qtInputDTSStart
    //property string dtsrepeat : qtInputDTSRepeat
    property string dtsrepeat : qtInputDTSRepeatHumanReadable
    property string dtsend : qtInputDTSEnd
    property string itemDuration: qtInputItemDuration
    property string raciResponsible : qtInputRACIResponsible
    property string raciAccountable : qtInputRACIAccountable
    property string raciConsulted : qtInputRACIConsulted
    property string raciInformed : qtInputRACIInformed
//    property string itemCreatedDTS: qtItemCreatedDTS

    property string dtsreviewSQLDate : qtInputDTSReviewSQLDate
    property string dtsstartSQLDate : qtInputDTSStartSQLDate
    property string dtsrepeatHumanReadable : qtInputDTSRepeatHumanReadable
    property string dtsendSQLDate : qtInputDTSEndSQLDate
    property string dtsdurationDays: qtInputDTSDurationDays
    property string dtsdurationHours: qtInputDTSDurationHours
    property string dtsdurationMinutes: qtInputDTSDurationMinutes
    property string dtsdurationHumandReadable: qtInputDTSDurationHumanReadable
    property int dtsSecurityLevel: qtInputSecurityLevel

    property bool fieldChange : false

    property int activeInputFieldID : 0

    property Gradient buttonBackgroundGradient: Gradient {
        GradientStop { position: 0.0; color: "white" }
        GradientStop { position: 1.0; color: "#d9d9d9" }
    }

    property Gradient buttonPressedBackgroundGradient: Gradient {
        GradientStop { position: 0.0; color: "#d9d9d9" }
        GradientStop { position: 1.0; color: "white" }
    }

    property color tabPanelMarkerColor: "#d9d9d9"
    property Gradient tabPanelBackgroundGradient: Gradient {
        GradientStop { position: 0.0; color: "white" }
        GradientStop { position: 0.5; color: "#dddddd" }
        GradientStop { position: 1.0; color: "white" }
    }

    signal contextAssignmentChanged();

    Keys.enabled: true
    Keys.onCancelPressed: QtHandler.CloseButtonClicked();
    Keys.onEscapePressed: QtHandler.CloseButtonClicked();
    Keys.onEnterPressed: {
        //console.debug("onEnterPressed")
        reviewAllDataForChanges()
    }

    onActiveFocusChanged: {
        //console.debug("QML++ onActiveFocusChanged")
    }

    onItemTypeChanged: {
        displayedItemTypeChanged();
    }

    function initFromDefaults() {
        //console.debug("initFromDefaults");
        titleinput.itemTitle = mainrectangle.itemName;
        titleinput.itemCompleted = !(mainrectangle.itemCompletedDTS === "");
        titleinput.itemFlagged = mainrectangle.itemFlag;

        notePanel.itemPriority = mainrectangle.itemPriority
        notePanel.itemComment = mainrectangle.itemComment
        notePanel.itemColor = mainrectangle.itemColor

        reviewPanel.itemAIDType = mainrectangle.itemAIDType
        reviewPanel.itemReviewDTSHR = mainrectangle.dtsreview
        reviewPanel.itemContextHR = mainrectangle.context
        reviewPanel.itemLocation = mainrectangle.itemLocation
        reviewPanel.itemStartDTSHR = mainrectangle.dtsstart
        reviewPanel.itemRepeatDTSHR = mainrectangle.dtsrepeat
        reviewPanel.itemEndDTSHR = mainrectangle.dtsend
        reviewPanel.itemDuration = mainrectangle.itemDuration
        reviewPanel.itemSecurityLevelHR = mainrectangle.itemSecurityLevelHR

        morePanel.itemProgress = mainrectangle.itemProgress
        morePanel.itemRACIRescponsibleHR = mainrectangle.raciResponsible
        morePanel.itemRACIAccountableHR = mainrectangle.raciAccountable
        morePanel.itemRACIConsultedHR = mainrectangle.raciConsulted
        morePanel.itemRACIInformedHR = mainrectangle.raciInformed
//        morePanel.itemCreationDTSHR = mainrectangle.itemCreatedDTS
    }

    function editTitle() {
        notePanel.focus = false
        titleinput.forceActiveFocus()
        titleinput.edit()
    }

    function deactivateEdit() {
        notePanel.deactivateEdit()
        titleinput.deactivateEdit()
    }

    function multipleItemsSelected() {
        //console.debug("QML++ multipleItemsSelected")

        itemType = "M";
        displayedItemTypeChanged();
    }

    function noItemsSelected() {
        //console.debug("QML++ noItemsSelected")

        itemType = "";
        displayedItemTypeChanged();
    }

    function singleItemSelected() {
        //console.debug("QML++ singleItemSelected")

        itemType = "A";
        displayedItemTypeChanged();
    }

    function displayedItemTypeChanged() {
        //console.debug("QML++ displayedItemTypeChanged")
        //console.debug(itemType)
        //console.debug(itemUID)

        // load panel for item type
        // A = Action Item
        // M = Multiple Selections
        // All others are internal / No item selected

        if (itemType == "A") {
            tabActionItemDetailsEditor.visible = true
            tabInternalNoSelection.visible = false
            tabInternalMultiSelection.visible = false

        } else if (itemType == "M") {
            tabActionItemDetailsEditor.visible = false
            tabInternalNoSelection.visible = false
            tabInternalMultiSelection.visible = true

        } else {
            tabActionItemDetailsEditor.visible = false
            tabInternalNoSelection.visible = true
            tabInternalMultiSelection.visible = false
        }
    }

    function activateFirstInputOnPanel() {
        //console.debug("QML++ AIActionDetailsInspector activateFirstInputOnPanel")
    }

    function reviewAllDataForChanges() {

    }


    Rectangle {
        id: windowRect
        opacity: 0.9
        color: "#eeffffff"

        radius: 6
        smooth: true
        anchors.fill: parent
        anchors.rightMargin: (mainrectangle.platformID == "WIN" ? 1 : 0)
        anchors.leftMargin: (mainrectangle.platformID == "WIN" ? 1 : 0)
        anchors.bottomMargin: (mainrectangle.platformID == "WIN" ? 1 : 0)

        //
        // window title bar
        //

        XAWindowTitleBarWhite {
            id: xaWindowTitleBar
            //windowTitle: mainrectangle.windowTitle
            windowTitle: qsTr("Task Details Inspector")
            windowGotFocus: mainrectangle.windowGotFocus
            windowDrawBorder: (mainrectangle.platformID == "WIN")
            platformID: mainrectangle.platformID
            showCloseButton: (mainrectangle.platformID == "MAC")
        }

        //
        // TAB 1 - display item details
        //

        Item {
            id: tabActionItemDetailsEditor
            anchors.fill: parent
            anchors.leftMargin: (mainrectangle.platformID == "WIN" ? 1 : 0)

            AIActionDetailsTitleInput {
                id: titleinput
                anchors.top: parent.top
                anchors.topMargin: 20
                anchors.left: parent.left
                anchors.right: parent.right

                onTitleUpdated: {
                    if (mainrectangle.itemName != title) {
                        QtHandler.dataChanged(mainrectangle.itemUID, "name", title)
                    }
                }

                onFlaggedTriggered: {
                    QtHandler.dataChanged(mainrectangle.itemUID, "flagged", itemFlagged ? 1 : 0)
                }

                onCompletedTriggered: {
                    //QtHandler.dataChanged(mainrectangle.itemUID, "completed", itemCompleted ? 1 : 0)
                    QtHandler.changeCompleted(mainrectangle.itemUID, itemCompleted ? 1 : 0)
                }
            }

            Image {
                anchors.top: parent.top
                anchors.topMargin: 20 + titleinput.height
                anchors.left: parent.left
                anchors.right: parent.right
                //height: 11
                fillMode: Image.TileHorizontally
                smooth: true
                source: "qrc:/icons/shadowsbottom2px.png"
            }

            Rectangle {
                id: detailsPanel
                anchors.fill: parent
                anchors.topMargin: titleinput.height + 31
                anchors.bottomMargin: 33

                color: "white"

                property int tabWidths: 80
                property int tabHeights: 21
                property int tabCount: (editionID == "ME") ? 2 : 3

                property int tabStartPos: (detailsPanel.width / 2 - (detailsPanel.tabCount * detailsPanel.tabWidths / 2))

                function selectTab(tab) {
                    tab0.isSelected = false
                    tab1.isSelected = false
                    tab2.isSelected = false

                    QtHandler.closeAllPicker();

                    if (tab === 0) {
                        tab0.isSelected = true;

                        notePanel.visible = true;
                        reviewPanel.visible = false;
                        morePanel.visible = false;

                    } else if (tab === 1) {
                        tab1.isSelected = true

                        notePanel.visible = false;
                        reviewPanel.visible = true;
                        morePanel.visible = false;

                    } else if (tab === 2) {
                        tab2.isSelected = true

                        notePanel.visible = false;
                        reviewPanel.visible = false;
                        morePanel.visible = true;
                    }
                }

                AIInspectorTabPanelTab {
                    id: tab0
                    anchors.top: parent.top
                    height: detailsPanel.tabHeights
                    width: detailsPanel.tabWidths
                    anchors.left: parent.left
                    anchors.leftMargin: detailsPanel.tabStartPos

                    backgroundColor: "transparent"
                    selectionColor: tabPanelMarkerColor

                    text: qsTr("Note")
                    isSelected: true

                    onTriggered: {
                        //console.debug("Note triggered.")
                        detailsPanel.selectTab(0)
                    }
                }

                AIInspectorTabPanelTab {
                    id: tab1
                    anchors.top: parent.top
                    height: detailsPanel.tabHeights
                    width: detailsPanel.tabWidths
                    anchors.left: parent.left
                    anchors.leftMargin: detailsPanel.tabStartPos + width

                    backgroundColor: "transparent"
                    selectionColor: tabPanelMarkerColor

                    text: qsTr("Review")

                    onTriggered: {
                        //console.debug("Review triggered.")
                        detailsPanel.selectTab(1)
                    }
                }

                AIInspectorTabPanelTab {
                    id: tab2
                    anchors.top: parent.top
                    height: detailsPanel.tabHeights
                    width: detailsPanel.tabWidths
                    anchors.left: parent.left
                    anchors.leftMargin: detailsPanel.tabStartPos + width * 2

                    backgroundColor: "transparent"
                    selectionColor: tabPanelMarkerColor

                    visible: (editionID != "ME")

                    text: qsTr("...")

                    onTriggered: {
                        //console.debug("... triggered.")
                        detailsPanel.selectTab(2)
                    }
                }

                Rectangle {
                    id: tabPanelBaseLine
                    anchors.left: parent.left
                    anchors.top: parent.top
                    anchors.topMargin: detailsPanel.tabHeights
                    anchors.right: parent.right
                    height: 1

                    color: tabPanelMarkerColor
                }

                Rectangle {
                    id: tabPanelBottomLine
                    anchors.left: parent.left
                    anchors.bottom: parent.bottom
                    anchors.right: parent.right
                    height: 1

                    color: tabPanelMarkerColor
                }

                Rectangle {
                    id: tabPanelContentRect
                    anchors.left: parent.left
                    anchors.right: parent.right
                    anchors.bottom: parent.bottom
                    anchors.bottomMargin: 1
                    anchors.top: parent.top
                    anchors.topMargin: detailsPanel.tabHeights+1

                    gradient: tabPanelBackgroundGradient

                    AIActionDetailsNotePanel {
                        id: notePanel
                        anchors.fill: parent

                        onPriorityTriggered: {
                            //console.debug("Priority in Inspector changed to: ")
                            //console.debug(newPriority)
                            QtHandler.dataChanged(mainrectangle.itemUID, "priority", newPriority)
                        }

                        onCommentUpdated: {
                            //console.debug("Comment in Inspector changed to: ")
                            //console.debug(newComment)
                            QtHandler.dataChanged(mainrectangle.itemUID, "comment", newComment)
                            QtHandler.dataChanged(mainrectangle.itemUID, "delegatedto", "1")
                        }

                        onCommentFocusRequested: {
                            titleinput.focus = false;
                        }

                        onColorTriggered: {
                            //console.debug("Color in Inspector changed to: ")
                            //console.debug(newColor)
                            QtHandler.dataChanged(mainrectangle.itemUID, "consulted", newColor)
                        }
                    }

                    AIActionDetailsReviewPanel {
                        id: reviewPanel
                        anchors.fill: parent
                        editionID: mainrectangle.editionID

                        visible: false

                        onAidTypeTriggered: {
                            //console.debug("AID in Inspector changed to: ")
                            //console.debug(newAIDType)
                            QtHandler.dataChanged(mainrectangle.itemUID, "task_type", newAIDType)
                        }

                        onDisplayDatePickerAt: {
                            //console.debug("Date Picker requested in Inspector")
                            QtHandler.displayDatePickerAt(field, x, y)
                        }

                        onDisplayContextPickerAt: {
                            //console.debug("Context Picker requested in Inspector")
                            QtHandler.displayContextPickerAt(contextType, x, y)
                        }

                        onLocationUpdated: {
                            //console.debug("Location in Inspector changed to: ")
                            //console.debug(newLocation)
                            QtHandler.dataChanged(mainrectangle.itemUID, "location", newLocation)
                        }

                        onDisplayRepeatPickerAt: {
                            //console.debug("Repeat Picker requested in Inspector")
                            QtHandler.displayRepeatPickerAt(field, x, y)
                        }

                        onDurationUpdated: {
                            //console.debug("Duration in Inspector changed to: ")
                            //console.debug(newDuration)
                            QtHandler.dataChanged(mainrectangle.itemUID, "duration", newDuration)
                        }

                        onDisplaySecurityLevelPickerAt: {
                            //console.debug("Security Picker requested in Inspector")
                            QtHandler.displaySecurityLevelPickerAt(field, x, y)
                        }
                    }

                    AIActionDetailsMorePanel {
                        id: morePanel
                        anchors.fill: parent

                        visible:false

                        onProgressUpdated: {
                            //console.debug("Progress in Inspector changed to: ")
                            //console.debug(newProgress)
                            QtHandler.dataChanged(mainrectangle.itemUID, "progresspercent", newProgress)
                        }

                        onDisplayContextPickerAt: {
                            //console.debug("Context Picker requested in Inspector")
                            QtHandler.displayContextPickerAt(contextType, x, y)
                        }
                    }

                }

            }
        }

        //
        // TAB 2 - no selection
        //

        Item {
            id: tabInternalNoSelection
            anchors.fill: parent

            Text {
                id: titleInternalNoSelection_labelShadow

                anchors.horizontalCenter: parent.horizontalCenter
                anchors.verticalCenter: parent.verticalCenter
                anchors.verticalCenterOffset: 1

                text: titleInternalNoSelection_label.text
                color: "white"
                font.family: "Arial"
                font.pixelSize: 28
                font.bold: true
                smooth: true
            }

            Text {
                id: titleInternalNoSelection_label
                //anchors.fill: parent

                anchors.horizontalCenter: parent.horizontalCenter
                anchors.verticalCenter: parent.verticalCenter

                text: qsTr("No item selected.")
                color: "#e0e0e0"
                font.family: "Arial"
                font.pixelSize: 28
                font.bold: true
                smooth: true
            }
        }

        //
        // TAB 2 - multiple item selection
        //

        Item {
            id: tabInternalMultiSelection
            anchors.fill: parent

            Text {
                id: titleInternalMultiSelection_labelShadow

                anchors.horizontalCenter: parent.horizontalCenter
                anchors.verticalCenter: parent.verticalCenter
                anchors.verticalCenterOffset: 1

                text: titleInternalMultiSelection_label.text
                color: "white"
                font.family: "Arial"
                font.pixelSize: 28
                font.bold: true
                smooth: true
            }

            Text {
                id: titleInternalMultiSelection_label
                //anchors.fill: parent

                anchors.horizontalCenter: parent.horizontalCenter
                anchors.verticalCenter: parent.verticalCenter

                text: qsTr("Multiple items selected.")
                color: "#e0e0e0"
                font.family: "Arial"
                font.pixelSize: 28
                font.bold: true
                smooth: true
            }
        }

        //
        // button to close dialog
        //

        Rectangle {
            id: buttonDoneBackground
            anchors.bottom: parent.bottom
            anchors.right: parent.right
            anchors.bottomMargin: 6
            anchors.rightMargin: 6

            width: 80
            height: 21

            gradient: buttonBackgroundGradient
            radius: 4
            border.color: "#9f9f9f"
            border.width: 1

            smooth: true

            Text {
                id: buttonDoneLabel

                anchors.horizontalCenter: parent.horizontalCenter
                anchors.verticalCenter: parent.verticalCenter

                text: qsTr("Done")
                color: "black"
                font.family: "Arial"
                font.pixelSize: 12
                font.bold: false
                smooth: true
            }

            MouseArea {
                anchors.fill: parent

                onPressed: buttonDoneBackground.gradient = buttonPressedBackgroundGradient
                onReleased: buttonDoneBackground.gradient = buttonBackgroundGradient

                onClicked: {
                    reviewAllDataForChanges();
                    QtHandler.close()
                }
            }
        }
    }

    Component.onCompleted: {
        displayedItemTypeChanged();
    }
}
