import Qt 4.7

Item {
    id: xaqmlFolderTypePicker
    width: 250
    height: 364

    property bool enabled: true

    property bool folderFlagged: true
    property string folderFlaggedResult: ""

    property string folderTypeString : ""
    property int repeaterTypeSegmentSelected

    property string folderTrafficLightString : ""
    property int repeaterTrafficLightSegmentSelected

    property string folderActivityString : ""
    property int repeaterActivitySegmentSelected

    signal folderTrafficLightStringResultUpdated()
    signal folderActivityStringResultUpdated()
    signal folderFlaggingUpdated()
    signal folderTypeStringResultUpdated()

    function updatePreview() {
//        console.debug("QML++ updatePreview")

        if (folderTypeString.charAt(0) == "1") {
            // regular folder
            if (folderFlagged) iconPreviewImage.source = "qrc:icons2/FolderIconMonoFolderFlagged22.png"
            else iconPreviewImage.source = "qrc:icons2/FolderIconMonoFolder22.png"

        } else if (folderTypeString.charAt(0) == "2") {
            // meeting folder
            if (folderFlagged) iconPreviewImage.source = "qrc:icons2/FolderIconMonoMeetingFlagged22.png"
            else iconPreviewImage.source = "qrc:icons2/FolderIconMonoMeeting22.png"

        } else {
            // project folder
            if (folderFlagged) iconPreviewImage.source = "qrc:icons2/FolderIconMonoProjectBFlagged22.png"
            else iconPreviewImage.source = "qrc:icons2/FolderIconMonoProjectB22.png"
        }

        if (folderTrafficLightString.charAt(0) == "1") iconPreviewTagImage.source = "qrc:icons2/FolderTrafficLightYellow40.png";
        else if (folderTrafficLightString.charAt(0) == "2") iconPreviewTagImage.source = "qrc:icons2/FolderTrafficLightRed40.png";
        else iconPreviewTagImage.source = "qrc:icons2/FolderTrafficLightGreen40.png";

        if (folderActivityString.charAt(0) == "1") iconPreviewRunStatusOverlayImage.source = "qrc:icons2/RunStatusPause10px.png";
        else if (folderActivityString.charAt(0) == "2") iconPreviewRunStatusOverlayImage.source = "qrc:icons2/RunStatusStop10px.png";
        else if (folderActivityString.charAt(0) == "3") iconPreviewRunStatusOverlayImage.source = "qrc:icons2/RunStatusCompleted10px.png";
        else iconPreviewRunStatusOverlayImage.source = "";
    }

    onFolderFlaggedChanged: {
//        console.debug("QML++ onFolderFlaggedChanged")
        flaggingOnOff.switchOn = xaqmlFolderTypePicker.folderFlagged
        flaggingOnOff.loadSettings();

        updatePreview();
    }

    onFolderTrafficLightStringChanged: {
//        console.debug("onFolderTrafficLightStringChanged")
//        console.debug(folderTrafficLightString)

        // 0 = Green
        // 1 = Yellow
        // 2 = Red

        if (folderTrafficLightString.charAt(0) == "1") repeaterTrafficLightSegmentSelected = 1;
        else if (folderTrafficLightString.charAt(0) == "2") repeaterTrafficLightSegmentSelected = 2;
        else repeaterTrafficLightSegmentSelected = 0;

        segmentTrafficLightGrid.currentIndex = repeaterTrafficLightSegmentSelected

        updatePreview();
    }

    onFolderActivityStringChanged: {
//        console.debug("onFolderActivityStringChanged")
//        console.debug(folderActivityString)

        // 0 = Active
        // 1 = On Hold
        // 2 = Cancelled
        // 3 = Completed

        if (folderActivityString.charAt(0) == "1") repeaterActivitySegmentSelected = 1;
        else if (folderActivityString.charAt(0) == "2") repeaterActivitySegmentSelected = 2;
        else if (folderActivityString.charAt(0) == "3") repeaterActivitySegmentSelected = 3;
        else repeaterActivitySegmentSelected = 0;

        segmentActivityGrid.currentIndex = repeaterActivitySegmentSelected

        updatePreview();
    }

    onFolderTypeStringChanged: {
//        console.debug("QML++ xaqmlFolderTypePicker onFolderTypeStringChanged")
//        console.debug(folderTypeString)

        // 0 = Project
        // 1 = Folder (Generic)
        // 2 = Meeting

        if (folderTypeString.charAt(0) == "1") repeaterTypeSegmentSelected = 1;
        else if (folderTypeString.charAt(0) == "2") repeaterTypeSegmentSelected = 2;
        else repeaterTypeSegmentSelected = 0;

        segmentGrid.currentIndex = repeaterTypeSegmentSelected

        updatePreview();
    }

    function updateFolderTrafficLightString() {
//        console.debug("updateFolderTrafficLightString")
//        console.debug(repeaterTrafficLightSegmentSelected)

        if (repeaterTrafficLightSegmentSelected == 1) folderTrafficLightString = "1";
        else if (repeaterTrafficLightSegmentSelected == 2) folderTrafficLightString = "2";
        else folderTrafficLightString = "0";

//        console.debug(folderTrafficLightString)
        folderTrafficLightStringResultUpdated()
    }

    function updateFolderActivityString() {
//        console.debug("updateFolderActivityString")
//        console.debug(repeaterActivitySegmentSelected)

        if (repeaterActivitySegmentSelected == 1) folderActivityString = "1";
        else if (repeaterActivitySegmentSelected == 2) folderActivityString = "2";
        else if (repeaterActivitySegmentSelected == 3) folderActivityString = "3";
        else folderActivityString = "0";

//        console.debug(folderActivityString)
        folderActivityStringResultUpdated()
    }

    function updateFolderTypeString() {
//        console.debug("QML++ xaqmlFolderTypePicker updateFolderTypeString")
//        console.debug(repeaterTypeSegmentSelected)

        if (repeaterTypeSegmentSelected == 1) folderTypeString = "1";
        else if (repeaterTypeSegmentSelected == 2) folderTypeString = "2";
        else folderTypeString = "0";

//        console.debug(folderTypeString)
        folderTypeStringResultUpdated()
    }

    ListModel {
        id: segmentModel

        ListElement {
            name: "Project"
            checked: "1"
        }
        ListElement {
            name: "Folder"
            checked: "0"
        }
        ListElement {
            name: "Meeting"
            checked: "0"
        }

        function i18n(index) {
            if (i18n["text"] === undefined) {
                i18n.text = [
                            qsTr("Project"),
                            qsTr("Folder"),
                            qsTr("Meeting")
                        ]
            }
            return i18n.text[index]
        }
    }

    ListModel {
        id: segmentTrafficLightModel

        ListElement {
            name: "Green"
            checked: "1"
        }
        ListElement {
            name: "Yellow"
            checked: "0"
        }
        ListElement {
            name: "Red"
            checked: "0"
        }

        function i18n(index) {
            if (i18n["text"] === undefined) {
                i18n.text = [
                            qsTr("Green"),
                            qsTr("Yellow"),
                            qsTr("Red")
                        ]
            }
            return i18n.text[index]
        }
    }

    ListModel {
        id: segmentActivityModel

        ListElement {
            name: "Active"
            checked: "1"
        }
        ListElement {
            name: "On Hold"
            checked: "0"
        }
        ListElement {
            name: "Cancelled"
            checked: "0"
        }
        ListElement {
            name: "Completed"
            checked: "0"
        }

        function i18n(index) {
            if (i18n["text"] === undefined) {
                i18n.text = [
                            qsTr("Active"),
                            qsTr("On Hold"),
                            qsTr("Cancelled"),
                            qsTr("Completed")
                        ]
            }
            return i18n.text[index]
        }
    }

    //
    // preview line with selected icon
    //

    Rectangle {
        id: iconPreviewRect
        anchors.left: parent.left
        anchors.leftMargin: 10
        anchors.right: parent.right
        anchors.rightMargin: 10
        anchors.top: parent.top
        anchors.topMargin: 0
        height: 24
        //color:  "#55000000"
        color: "#e0e4ef"

        border.width: 1
        border.color: "black"

        Image {
            id: iconPreviewImage
            anchors.left: parent.left
            anchors.leftMargin: 5
            anchors.top: parent.top
//            anchors.topMargin: -1
        }

        Image {
            id: iconPreviewRunStatusOverlayImage
            anchors.left: parent.left
            anchors.leftMargin: 14
            anchors.top: parent.top
            anchors.topMargin: 11
        }

        Text {
            anchors.left: parent.left
            anchors.leftMargin: 30
            anchors.verticalCenter: parent.verticalCenter

            font.family: "Lucida Grande"
            font.pointSize: 13
            font.bold: false
            color: "black"

            text: "Folder Preview"
        }

        Image {
            id: iconPreviewTagImage
            anchors.right: parent.right
            anchors.rightMargin: 0
            anchors.top: parent.top
            anchors.topMargin: -8
        }
    }

    XAHDivisionLine {
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 40
    }

    //
    // flagging on/off control
    //

    Item {
        id: flaggingOnOffControl
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 43
        anchors.bottom: parent.bottom

        Rectangle {
            id: flaggingOnOffControlRect
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: 10
            height: 25
            clip: true
            //color: "black"
            color: "transparent"

            XAOnOffSelector2 {
                id: flaggingOnOff
                anchors.left: parent.left
                anchors.right: parent.right
                anchors.top: parent.top
                anchors.topMargin: 0

                labelText: qsTr("Flagged:")
                switchOn: xaqmlFolderTypePicker.folderFlagged

                onSwitchChanged: {
//                    console.debug("QML++ switch changed")

//                    if (switchOn) console.debug("SWITCH IS ON")
//                    else console.debug("SWITCH IS OFF")

                    if (switchOn) folderFlaggedResult = "1"
                    else folderFlaggedResult = "0"

                    folderFlaggingUpdated();
                }
            }
        }
    }

    XAHDivisionLine {
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 85
    }

    //
    // repeat segment control
    //

    Item {
        id: repeatSegmentControl
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        //anchors.topMargin: 170
        anchors.topMargin: 110
        anchors.bottom: parent.bottom

        Text {
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: -10
            anchors.leftMargin: 6
            height: 20

            color: "white"
            font.pixelSize: 12
            //font.family: "Helvetica"
            font.family: "Arial"
            font.bold: true
            smooth: true

            text: "Folder Type"
        }

        Rectangle {
            id: repeatSegmentControlRect
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: 10
            height: 25
            clip: true
            color: "black"

            GridView {
                id: segmentGrid
                anchors.fill: parent
                anchors.topMargin: 1
                anchors.leftMargin: 2
                anchors.rightMargin: 2

                cellWidth: parent.width / model.count - 2; cellHeight: parent.height - 4

                model: segmentModel
                delegate: segmentCellDelegate
                //highlight: Rectangle { color: "lightsteelblue"; radius: 5; smooth: true; border.color: "white"; border.width: 1}
                //highlight: Rectangle { color: "#3e3c3c"; radius: 5; smooth: true; border.color: "white"; border.width: 1}
                //focus: true
                highlight: Rectangle { color: "#40ffffff"; radius: 1; smooth: true; border.color: "white"; border.width: 1}

                onVisibleChanged: {
                    if (visible) {
                        segmentGrid.currentIndex = repeaterTypeSegmentSelected;
                    }
                }

                onCurrentIndexChanged: {
//                    console.debug("repeaterTypeSegmentSelected onCurrentIndexChanged")
                }

                Component {
                    id: segmentCellDelegate

                    Item {
                        id: segmentCellDelegateItem
                        width: segmentGrid.cellWidth; height: segmentGrid.cellHeight

                        MouseArea {
                            anchors.fill: parent
                            onClicked: {
                                segmentGrid.currentIndex = index;
                                repeaterTypeSegmentSelected = index;

                                updateFolderTypeString();
                            }
                        }

//                        Column {
                        Item {
                            id: segmentCellDelegateColumn
                            anchors.topMargin: 2
                            anchors.bottomMargin: 2
                            anchors.left: parent.left
                            anchors.leftMargin: 1
                            anchors.right: parent.right
                            anchors.rightMargin: 1

                            Text {
                                //text: name;
                                text: segmentGrid.model.i18n(index)
                                font.family: "Arial";
                                font.bold: true;
                                //font.pointSize: 11;
                                font.pixelSize: 11
                                anchors.top: parent.top
                                anchors.topMargin: 4
                                anchors.horizontalCenter: parent.horizontalCenter
                                color: "white";
                                smooth: true;
                            }
                        }
                    }
                }
            }
        }
    }

    //
    // traffic light segment control
    //

    Item {
        id: repeatSegmentTrafficLightControl
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 170
        anchors.bottom: parent.bottom

        Text {
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: -10
            anchors.leftMargin: 6
            height: 20

            color: "white"
            font.pixelSize: 12
            //font.family: "Helvetica"
            font.family: "Arial"
            font.bold: true
            smooth: true

            text: qsTr("Traffic Light")
        }

        Rectangle {
            id: repeatSegmentTrafficLightControlRect
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: 10
            height: 25
            clip: true
            color: "black"

            GridView {
                id: segmentTrafficLightGrid
                anchors.fill: parent
                anchors.topMargin: 1
                anchors.leftMargin: 2
                anchors.rightMargin: 2

                cellWidth: parent.width / model.count - 2; cellHeight: parent.height - 4

                model: segmentTrafficLightModel
                delegate: segmentTrafficLightCellDelegate
                //highlight: Rectangle { color: "lightsteelblue"; radius: 5; smooth: true; border.color: "white"; border.width: 1}
                //highlight: Rectangle { color: "#3e3c3c"; radius: 5; smooth: true; border.color: "white"; border.width: 1}
                //focus: true
                highlight: Rectangle { color: "#40ffffff"; radius: 1; smooth: true; border.color: "white"; border.width: 1}

                onVisibleChanged: {
                    if (visible) {
                        segmentTrafficLightGrid.currentIndex = repeaterTrafficLightSegmentSelected;
                    }
                }

                onCurrentIndexChanged: {
//                    console.debug("repeaterTypeSegmentSelected onCurrentIndexChanged")
                }

                Component {
                    id: segmentTrafficLightCellDelegate

                    Item {
                        id: segmentTrafficLightCellDelegateItem
                        width: segmentTrafficLightGrid.cellWidth; height: segmentTrafficLightGrid.cellHeight

                        MouseArea {
                            anchors.fill: parent
                            onClicked: {
                                segmentTrafficLightGrid.currentIndex = index;
                                repeaterTrafficLightSegmentSelected = index;

                                updateFolderTrafficLightString();
                            }
                        }

//                        Column {
                        Item {
                            id: segmentTrafficLightCellDelegateColumn
                            anchors.topMargin: 2
                            anchors.bottomMargin: 2
                            anchors.left: parent.left
                            anchors.leftMargin: 1
                            anchors.right: parent.right
                            anchors.rightMargin: 1

                            Text {
                                //text: name;
                                text: segmentTrafficLightGrid.model.i18n(index)
                                font.family: "Arial";
                                font.bold: true;
                                //font.pointSize: 11;
                                font.pixelSize: 11
                                anchors.top: parent.top
                                anchors.topMargin: 4
                                anchors.horizontalCenter: parent.horizontalCenter
                                color: "white";
                                smooth: true;
                            }
                        }
                    }
                }
            }
        }
    }

    //
    // activity segment control
    //

    Item {
        id: repeatSegmentActivityControl
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 230
        anchors.bottom: parent.bottom

        Text {
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: -10
            anchors.leftMargin: 6
            height: 20

            color: "white"
            font.pixelSize: 12
            //font.family: "Helvetica"
            font.family: "Arial"
            font.bold: true
            smooth: true

            text: qsTr("Activity")
        }

        Rectangle {
            id: repeatSegmentActivityControlRect
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: 10
            height: 25
            clip: true
            color: "black"

            GridView {
                id: segmentActivityGrid
                anchors.fill: parent
                anchors.topMargin: 1
                anchors.leftMargin: 2
                anchors.rightMargin: 2

                cellWidth: parent.width /  model.count - 2; cellHeight: parent.height - 4

                model: segmentActivityModel
                delegate: segmentActivityCellDelegate
                //highlight: Rectangle { color: "lightsteelblue"; radius: 5; smooth: true; border.color: "white"; border.width: 1}
                //highlight: Rectangle { color: "#3e3c3c"; radius: 5; smooth: true; border.color: "white"; border.width: 1}
                //focus: true
                highlight: Rectangle { color: "#40ffffff"; radius: 1; smooth: true; border.color: "white"; border.width: 1}

                onVisibleChanged: {
                    if (visible) {
                        segmentActivityGrid.currentIndex = repeaterActivitySegmentSelected;
                    }
                }

                onCurrentIndexChanged: {
//                    console.debug("repeaterTypeSegmentSelected onCurrentIndexChanged")
                }

                Component {
                    id: segmentActivityCellDelegate

                    Item {
                        id: segmentActivityCellDelegateItem
                        width: segmentActivityGrid.cellWidth; height: segmentActivityGrid.cellHeight

                        MouseArea {
                            anchors.fill: parent
                            onClicked: {
                                segmentActivityGrid.currentIndex = index;
                                repeaterActivitySegmentSelected = index;

                                updateFolderActivityString();
                            }
                        }

//                        Column {
                        Item {
                            id: segmentActivityCellDelegateColumn
                            anchors.topMargin: 2
                            anchors.bottomMargin: 2
                            anchors.left: parent.left
                            anchors.leftMargin: 1
                            anchors.right: parent.right
                            anchors.rightMargin: 1

                            Text {
                                id: segActivityTitle
                                //text: name;
                                text: segmentActivityGrid.model.i18n(index)
                                font.family: "Arial";
                                font.bold: true;
                                font.pixelSize: 8
                                anchors.top: parent.top
                                anchors.topMargin: 6
                                anchors.horizontalCenter: parent.horizontalCenter
                                color: "white";
                                smooth: true;
                            }
                        }

                    }
                }
            }
        }
    }

    XAHDivisionLine {
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 275
    }

}
